<template>
  <div class="app-container">
    <div>
      <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
        <el-form-item label="请假类型" prop="type">
          <el-select v-model="queryParams.type" placeholder="请选择请假类型" clearable size="small">
            <el-option
              v-for="dict in typeOptions"
              :key="dict.dictValue"
              :label="dict.dictLabel"
              :value="dict.dictValue"
            />
          </el-select>
        </el-form-item>
        <el-form-item label="月份" prop="month">
          <el-select v-model="queryParams.month" placeholder="请选择请假月份" clearable size="small">
            <el-option
              v-for="item in yf"
              :key="item"
              :label="item"
              :value="item"
            />
          </el-select>
        </el-form-item>
        <el-form-item>
          <el-button type="cyan" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
          <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
        </el-form-item>
      </el-form>

      <el-row :gutter="10" class="mb8">
        <el-col :span="1.5">
          <el-button
            type="primary"
            icon="el-icon-plus"
            size="mini"
            @click="handleExport"
          >导出
          </el-button>
        </el-col>
        <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
      </el-row>

      <el-table v-loading="loading" :data="leaveList" @selection-change="handleSelectionChange">
        <el-table-column type="selection" width="55" align="center"/>
        <!--      <el-table-column label="ID" align="center" prop="id" width="40"/>-->
        <el-table-column label="请假类型" align="center" prop="type" :formatter="typeFormat" width="75">
          <template slot-scope="scope">
            <dict-tag :options="dict.type.app_vacate_type" :value="scope.row.type"/>
          </template>
        </el-table-column>
        <el-table-column label="标题" align="center" prop="title" width="140"/>
        <el-table-column label="原因" align="center" prop="reason" width="120"/>
        <el-table-column label="开始时间" align="center" prop="leaveStartTime" width="120">
          <template slot-scope="scope">
            <span>{{ parseTime(scope.row.leaveStartTime, '{y}-{m}-{d}') }}</span>
          </template>
        </el-table-column>
        <el-table-column label="结束时间" align="center" prop="leaveEndTime" width="120">
          <template slot-scope="scope">
            <span>{{ parseTime(scope.row.leaveEndTime, '{y}-{m}-{d}') }}</span>
          </template>
        </el-table-column>
        <el-table-column label="天数" align="center" prop="totalTime"/>
        <!--<el-table-column label="请假时长" align="center" prop="totalTime" />-->
        <!--      <el-table-column label="流程实例ID" align="center" prop="instanceId"/>-->
        <el-table-column label="申请人" align="center" prop="applyUserName"/>
        <el-table-column label="申请时间" align="center" prop="applyTime" width="120">
          <template slot-scope="scope">
            <span>{{ parseTime(scope.row.applyTime, '{y}-{m}-{d}') }}</span>
          </template>
        </el-table-column>
        <el-table-column label="是否离沪" align="center" prop="isLh"/>
        <el-table-column label="出行方式" align="center" prop="tripMode"/>
        <el-table-column label="出行城市" align="center" prop="tripAddress"/>
        <el-table-column label="详细地址" align="center" prop="detailAddr"/>
        <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
          <template slot-scope="scope">
            <el-button
              size="mini"
              type="text"
              @click="getBizLeaveImg(scope.row.id)"
            >查看图片
            </el-button>
            <flowRecord ref="flowRecord" :data="scope.row"></flowRecord>
          </template>
        </el-table-column>
      </el-table>

      <pagination
        v-show="total>0"
        :total="total"
        :page.sync="queryParams.pageNum"
        :limit.sync="queryParams.pageSize"
        @pagination="getList"
      />
    </div>
    <div>
      <el-dialog title="查看图片" :visible.sync="open" width="750px" append-to-body>
        <el-carousel trigger="click" height="750px">
          <el-carousel-item v-for="item in bizLeaveImg" :key="item.id">
            <div style="padding: 10px;align-items: center;text-align: center">
              <img :src="item.url"/>
            </div>
          </el-carousel-item>
        </el-carousel>
      </el-dialog>
    </div>
  </div>
</template>

<script>
import {
  listLeave,
  getLeave,
  delLeave,
  addLeave,
  updateLeave,
  exportLeave,
  getBizLeaveImg
} from "@/api/leave/leave";
import flowRecord from "@/views/components/flow/flowRecord";

export default {
  components: {
    flowRecord
  },
  name: "Leave",
  dicts: ['app_vacate_type'],
  data() {
    return {
      baseUrl: process.env.VUE_APP_BASE_API,
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 请假表格数据
      leaveList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 请假类型字典
      typeOptions: [],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        type: null,
        title: null,
        leaveStartTime: null,
        leaveEndTime: null,
        applyUserId: null,
        applyUserName: null,
        applyTime: null,
        instanceId: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        type: [
          {required: true, message: "请假类型不能为空", trigger: "blur"},
        ],
        title: [
          {required: true, message: "标题不能为空", trigger: "blur"},
        ],
        reason: [
          {required: true, message: "原因不能为空", trigger: "blur"},
        ],
        leaveStartTime: [
          {required: true, message: "开始时间不能为空", trigger: "blur"},
        ],
        leaveEndTime: [
          {required: true, message: "结束时间不能为空", trigger: "blur"},
        ],
      },
      requestMapping: '/leave/leave',
      yf: ['01', '02', '03', '04', '05', '06', '07', '08', '09', '10', '11', '12'],
      bizLeaveImg: []
    };
  },
  created() {
    this.getList();
    this.getDicts("app_vacate_type").then(response => {
      this.typeOptions = response.data;
    });
  },
  methods: {
    /** 查询请假列表 */
    getList() {
      this.loading = true;
      listLeave(this.queryParams).then(response => {
        this.leaveList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    getBizLeaveImg(id) {
      this.open = true;
      let img = {
        bizLeaveId: id
      }
      getBizLeaveImg(img).then(result => {
        if (result.code === 200) {
          this.bizLeaveImg = result.data
        }
      })
    },
    // 请假类型字典翻译
    typeFormat(row, column) {
      return this.selectDictLabel(this.typeOptions, row.type);
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        type: null,
        title: null,
        reason: null,
        leaveStartTime: null,
        leaveEndTime: null,
        totalTime: null,
        realityStartTime: null,
        realityEndTime: null,
        applyUserId: null,
        applyUserName: null,
        applyTime: null,
        instanceId: null,
        processKey: null,
        delFlag: null,
        createBy: null,
        createTime: null,
        updateBy: null,
        updateTime: null,
        remark: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加请假";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getLeave(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改请假";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateLeave(this.form).then(response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addLeave(this.form).then(response => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.form = {}
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm('是否确认删除请假编号为"' + ids + '"的数据项?', "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      }).then(function () {
        return delLeave(ids);
      }).then(() => {
        this.getList();
        this.msgSuccess("删除成功");
      })
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有请假数据项?', "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      }).then(function () {
        return exportLeave(queryParams);
      }).then(response => {
        this.$download.name(response.msg)
      })
    }
  }
};
</script>
